import type { DevConfig, Rspack } from '../types';
import { type InitConfigsOptions } from './initConfigs';
export declare function createCompiler(options: InitConfigsOptions): Promise<{
    compiler: Rspack.Compiler | Rspack.MultiCompiler;
    rspackConfigs: Rspack.Configuration[];
}>;
export type MiddlewareCallbacks = {
    onInvalid: () => void;
    onDone: (stats: any) => void;
};
export type DevMiddlewareOptions = {
    /** To ensure HMR works, the devMiddleware need inject the hmr client path into page when HMR enable. */
    clientPaths?: string[];
    clientConfig: DevConfig['client'];
    publicPath?: string;
    /** When liveReload is disabled, the page does not reload. */
    liveReload?: boolean;
    etag?: 'weak' | 'strong';
    /** The options need by compiler middleware (like webpackMiddleware) */
    headers?: Record<string, string | string[]>;
    writeToDisk?: boolean | ((filename: string) => boolean);
    stats?: boolean;
    /** should trigger when compiler hook called */
    callbacks: MiddlewareCallbacks;
    /** whether use Server Side Render */
    serverSideRender?: boolean;
};
